from launch import LaunchDescription
from launch.actions import DeclareLaunchArgument
from launch.substitutions import LaunchConfiguration, TextSubstitution

from launch_ros.actions import Node

def generate_launch_description():
    ns_arg = DeclareLaunchArgument("ns", default_value=TextSubstitution(text="/dji0"))
    
    return LaunchDescription([
        ns_arg,
        Node(
            package='lrs_exec',
            output='screen',
            emulate_tty=True,            
            namespace=LaunchConfiguration('ns'),
            executable='exec_server',
            name='exec_server',
            parameters=[{

            }
            ]
        )
    ])

# Alt: prefix=['stdbuf -o L']
