from launch import LaunchDescription
from launch.actions import DeclareLaunchArgument
from launch.substitutions import LaunchConfiguration, TextSubstitution

from launch_ros.actions import Node

def generate_launch_description():
    ns_arg = DeclareLaunchArgument("ns", default_value=TextSubstitution(text="/dji0"))
    disp_type_arg = DeclareLaunchArgument("display_type", default_value=TextSubstitution(text="all"))
    name_arg = DeclareLaunchArgument("name", default_value=TextSubstitution(text="tst_streamer_all"))
    channel_arg = DeclareLaunchArgument("channel", default_value=TextSubstitution(text="0"))
    
    return LaunchDescription([
        ns_arg,
        disp_type_arg,
        name_arg,
        channel_arg,
        Node(
            package='lrs_exec',
            output='screen',
            emulate_tty=True,            
            namespace=LaunchConfiguration('ns'),
            executable='tst_streamer',
            name=LaunchConfiguration('name'),
#            arguments=["--ros-args", "--log-level", "error"],
            parameters = [{
                "display_type": LaunchConfiguration('display_type'),
                "channel": LaunchConfiguration('channel'),
            }]
        )
    ])

# Alt: prefix=['stdbuf -o L']
