import os

from ament_index_python.packages import get_package_share_directory

from launch import LaunchDescription
from launch.actions import DeclareLaunchArgument
from launch.substitutions import LaunchConfiguration, TextSubstitution

from launch_ros.actions import Node

from launch.actions import GroupAction
from launch_ros.actions import PushRosNamespace
from launch_ros.actions import SetParameter
from launch.actions import IncludeLaunchDescription
from launch.launch_description_sources import PythonLaunchDescriptionSource



def generate_launch_description():
    ns_arg1 = DeclareLaunchArgument("ns1", default_value=TextSubstitution(text="/ex0"))
    ns_arg2 = DeclareLaunchArgument("ns2", default_value=TextSubstitution(text="/ex1"))

    ex0_include = IncludeLaunchDescription(
        PythonLaunchDescriptionSource(
            os.path.join(
                get_package_share_directory('lrs_exec'),
                'exec.launch.py')),
        launch_arguments={"ns": LaunchConfiguration('ns1')}.items()
    )

    ex1_include = IncludeLaunchDescription(
        PythonLaunchDescriptionSource(
            os.path.join(
                get_package_share_directory('lrs_exec'),
                'exec.launch.py')),
        launch_arguments={"ns": LaunchConfiguration('ns2')}.items()
    )


    return LaunchDescription([
        ns_arg1,
        ns_arg2,
        ex0_include,
        ex1_include,
    ])    
