import threading
import rclpy
from rclpy.executors import MultiThreadedExecutor

from lrs_exec.executors import *
from lrs_exec.exec_util import get_executor_factory_class_objects

def main(args=None):
    name = "basic_executors"
    print(f'Hi from {name}.')

    rclpy.init(args=args)

    executor = MultiThreadedExecutor(num_threads=8)

    factory_classes = get_executor_factory_class_objects(globals())

    for cobj in factory_classes:
        print(f"{name} executors adding executor for:", cobj)        
        node = cobj()
        executor.add_node(node)

    print(f"Spinning {name}")
    try:
        executor.spin()
    except KeyboardInterrupt:
        pass

    executor.shutdown()
    rclpy.shutdown()

if __name__ == '__main__':
    main()
    
