import json

from lrs_msgs_tst.msg import TSTExecInfo

class ExecInfo():
    def __init__(self):
        self.can_be_aborted = False
        self.can_be_paused = False
        self.can_be_enoughed = False
        self.can_be_signaled = False
        self.signals = []

    def update(self, msg):
        # print("ExecInfo update:", msg)
        try:
            self.can_be_aborted = msg.can_be_aborted
            self.can_be_paused = msg.can_be_paused
            self.can_be_enoughed = msg.can_be_enoughed
            self.can_be_signaled = msg.can_be_signaled
            self.signals = msg.signals
        except Exception as exc:
            print(type(exc))
            print(exc)

    def get_exec_info_msg(self):
        msg = TSTExecInfo()
        try:
            msg.can_be_aborted = self.can_be_aborted
            msg.can_be_paused = self.can_be_paused
            msg.can_be_enoughed = self.can_be_enoughed
            msg.can_be_signaled = self.can_be_signaled
            msg.signals = self.signals
        except Exception as exc:
            print(type(exc))
            print(exc)
        return msg

    def set_exec_info(self, msg):
        try:
            self.can_be_aborted = msg.can_be_aborted
            self.can_be_paused = msg.can_be_paused
            self.can_be_enoughed = msg.can_be_enoughed
            self.can_be_signaled = msg.can_be_signaled
            self.signals = msg.signals
        except Exception as exc:
            print(type(exc))
            print(exc)
