import json

from lrs_msgs_tst.msg import TSTExecStatus

class ExecStatus():
    def __init__(self):
        self.revoked = False
        self.active = False
        self.waiting = False
        self.executing = False
        self.finished = False
        self.aborted = False
        self.succeeded = False
        self.was_finished = False
        self.paused = False
        self.tree_paused = False
        self.tree_aborted = False
        self.fail_reason = ""

    def update(self, msg):
        # print("exec_status update", msg)
        try:
            self.revoked = msg.revoked
            self.active = msg.active
            self.waiting = msg.waiting
            self.executing = msg.executing
            self.finished = msg.finished
            self.aborted = msg.aborted
            self.succeeded = msg.succeeded
            self.was_finished = msg.was_finished
            self.paused = msg.paused
            self.tree_paused = msg.tree_paused
            self.tree_aborted = msg.tree_aborted
            self.fail_reason = msg.fail_reason
        except Exception as exc:
            print(type(exc))
            print(exc)
        
    def get_exec_status_msg(self):
        msg = TSTExecStatus()
        msg.revoked = self.revoked
        msg.active = self.active
        msg.waiting = self.waiting
        msg.executing = self.executing
        msg.finished = self.finished
        msg.aborted = self.aborted
        msg.succeeded = self.succeeded
        msg.was_finished = self.was_finished
        msg.paused = self.paused
        msg.tree_paused = self.tree_paused
        msg.tree_aborted = self.tree_aborted
        msg.fail_reason = self.fail_reason
        return msg
