
class Parameters():
    def __init__(self, tni):
        # print("Parameters:", tni)
        self.tni = tni

    def get_value_from_list(self, paramlist, name):
        try:
            # print("paramlist:", name, paramlist)
            for param in paramlist:
                if param.name == name:
                    if param.have_value:
                        return param.value
                    if param.have_default_value:
                        return param.default_value
        except Exception as exc:
            print(type(exc))
            print(exc)
        return None

    def get_value_always(self, name, defvalue):
        try:
            val = self.get_value(name)
            if val:
                return val
        except Exception as exc:
            print("EXCEPTION get_value_always:", type(exc))
            print(exc)
        return defvalue

    def get_value(self, name, default=None):
        try:
            value = self.get_value_from_list(self.tni.string_params, name)
            if value:
                return value
            value = self.get_value_from_list(self.tni.strings_params, name)
            if value:
                return value
            value = self.get_value_from_list(self.tni.bool_params, name)
            if value or value==False:
                return value
            value = self.get_value_from_list(self.tni.int32_params, name)
            if value or value==0:
                return value
            value = self.get_value_from_list(self.tni.float64_params, name)
            print("VALUE:", value)
            if value or value==0.0:
                return value
            value = self.get_value_from_list(self.tni.float64s_params, name)
            if value:
                return value
            value = self.get_value_from_list(self.tni.geo_point_params, name)
            if value:
                return value
            value = self.get_value_from_list(self.tni.geo_points_params, name)
            if value:
                return value
            value = self.get_value_from_list(self.tni.geo_point_arrays_params, name)
            if value:
                return value
            value = self.get_value_from_list(self.tni.point_params, name)
            if value:
                return value
            value = self.get_value_from_list(self.tni.points_params, name)
            if value:
                return value
            value = self.get_value_from_list(self.tni.pose_params, name)
            if value:
                return value
        except Exception as exc:
            print("EXCEPTION get_value", type(exc))
            print(exc)
        print(f'RETURN DEFAULT PARAM VALUE FOR {name}: {default}')
        return default
    
    def basic_print(self, name, params):
        print(name)
        print("==================")
        for param in params:
            print(f'  {param.name}: {param.have_value}:{param.value} - {param.have_default_value}:{param.default_value}')
        
    def print(self):
        print("***************************START PARAMETERS")
        print(self.tni)
        print("************")
        print(self.tni.strings_params)
        print("************")
        try:
            if len(self.tni.string_params) > 0:
                self.basic_print("STRING", self.tni.string_params)
            if len(self.tni.strings_params) > 0:
                self.basic_print("STRINGS", self.tni.strings_params)
            if len(self.tni.bool_params) > 0:
                self.basic_print("BOOL", self.tni.bool_params)
            if len(self.tni.int32_params) > 0:
                self.basic_print("INT32", self.tni.int32_params)
            if len(self.tni.float64_params) > 0:
                self.basic_print("FLOAT64", self.tni.float64_params)
            if len(self.tni.float64s_params) > 0:
                self.basic_print("FLOAT64S", self.tni.float64s_params)
            if len(self.tni.geo_point_params) > 0:
                self.basic_print("GEO_POINT", self.tni.geo_point_params)
            if len(self.tni.geo_points_params) > 0:
                self.basic_print("GEO_POINTS", self.tni.geo_points_params)
            if len(self.tni.geo_point_arrays_params) > 0:
                self.basic_print("GEO_POINT_ARRAYS", self.tni.geo_point_arrays_params)
            if len(self.tni.point_params) > 0:
                self.basic_print("POINT", self.tni.point_params)
            if len(self.tni.points_params) > 0:
                self.basic_print("POINTS", self.tni.points_params)
            if len(self.tni.pose_params) > 0:
                self.basic_print("POSE", self.tni.pose_params)
        except Exception as exc:
            print("EXCEPTION print parameters", type(exc))
            print(exc)
        print("********************END PARAMETERS")
