import os
from glob import glob

from setuptools import setup

package_name = 'lrs_exec'

setup(
    name=package_name,
    version='0.0.0',
    packages=[package_name, f'{package_name}/executors'],
    data_files=[
        ('share/ament_index/resource_index/packages',
            ['resource/' + package_name]),
        ('share/' + package_name, ['package.xml']),
        (os.path.join('share', package_name, 'tst', 'config'), glob('config/*.json')),
        (os.path.join('share', package_name), glob('launch/*.launch.py')),
    ],
    install_requires=['setuptools'],
    zip_safe=True,
    maintainer='tompe',
    maintainer_email='tommy.persson@liu.se',
    description='TODO: Package description',
    license='TODO: License declaration',
    tests_require=['pytest'],
    entry_points={
        'console_scripts': [
            'resource = lrs_exec.resource:main',
            'tst_expansion = lrs_exec.tst_expansion:main',
            'tst_constraint = lrs_exec.tst_constraint:main',
            'tst_exec_factory = lrs_exec.tst_exec_factory:main',
            'tst_exec_manager = lrs_exec.tst_exec_manager:main',
            'basic_executors = lrs_exec.basic_executors:main',
            'tst_command = lrs_exec.tst_command:main',
            'tst_streamer = lrs_exec.tst_streamer:main',
            'to_rtmp = lrs_exec.to_rtmp:main',
            'conc = lrs_exec.executors.conc:main',
            'noop = lrs_exec.executors.noop:main',
            'yes_exec = lrs_exec.executors.yes:main',
            'say = lrs_exec.executors.say:main',
            'string_pub = lrs_exec.executors.string_pub:main',
            'mission = lrs_exec.executors.mission:main',
            'add_task_to_team_queue = lrs_exec.executors.add_task_to_team_queue:main',
            'input_handler = lrs_exec.executors.input_handler:main',
            'fail = lrs_exec.executors.fail:main',
            'collect_release = lrs_exec.executors.collect_release:main',
            'send_signal = lrs_exec.executors.send_signal:main',
            'seq = lrs_exec.executors.seq:main', 
            'start_data_recording = lrs_exec.executors.start_data_recording:main',
            'stop_data_recording = lrs_exec.executors.stop_data_recording:main',
            'supp = lrs_exec.executors.supp:main',
            'test_if = lrs_exec.executors.test_if:main',
            'wait = lrs_exec.executors.wait:main',
            'monitor = lrs_exec.executors.monitor:main',
            'wait_joy = lrs_exec.executors.wait_joy:main',
            'remote = lrs_exec.executors.remote:main',
            'look_at_position = lrs_exec.executors.look_at_position:main',            
            'tree_executor = lrs_exec.tree_executor:main',
            'exec_server = lrs_exec.exec_server:main',            
            'ros2_bridge = lrs_exec.ros2_bridge:main',            
            'scenario_handler = lrs_exec.scenario_handler:main',            
            'query = lrs_exec.executors.query:main',
            'computation = lrs_exec.executors.computation:main',
        ],
    },
)
